#!/usr/bin/perl
#
# Copyright (c) 2005 IDEALX
#
# <pallix@idealx.com>
#
# This software is under GNU PUBLIC LICENSE VERSION 2.

use Getopt::Long;
use File::Basename;
use strict;
use Cwd;

sub usage {
    print basename($0);
    print " : Add software of the section 'Extra' in the file comps to ";
    print "the AutoYaST XML file\n\n";
    print "Available options:\n\t";
    print "--comps <file> (comps file)\n\t";
    print "--autofile <file (AutoYaST XML file)\n\t";
    print "--outfile <file> (path to the final AutoYaST file)\n\t";
    print "[-h, --help] (this help text)\n\t";
    print "\n";
    exit(1);
}

my $help = 0;
my $autofile = "";
my $outfile = "";
my $comps = "";

GetOptions("h|help" => \$help, 
           "autofile=s" => \$autofile,
           "outfile=s" => \$outfile,
           "comps=s" => \$comps,
          );

if ($help
    || $autofile eq ""
    || $outfile eq ""
    || $comps eq ""
   ) {
    usage();
}

my $xml = "";
open(FILE, $comps) or die die "Unable to open '$comps' : $!\n";
while(<FILE>) {
    if(/ *(1|0) *(Extra)/) {
        while(<FILE>) {
            last if /}/;
            chomp;
            s/( +)//g;
          $xml .= "<package>$_</package>\n";

        }
    }
}
close(FILE);

open(IN, $autofile) or die "Unable to open '$autofile' : $!\n";
open(OUT, ">", $outfile) or die "Unable to open '$outfile' : $!\n";
while(<IN>) {
    if(/<\/packages/) {
        print OUT $xml;
    }
    print OUT;
}
close(IN);
close(OUT);

